-- name: [CS] Final Fantasy VII Pack
-- description: FF7 characters final their fantasy.
--[[
    API Documentation for Character Select can be found below:
    https://github.com/Squishy6094/character-select-coop/blob/main/API-doc.md
]]

local E_MODEL_CLOUD_MODEL = smlua_model_util_get_id("cloud_geo")

local TEXT_MOD_NAME = "Cloud Strife"

local VOICETABLE_CLOUD = {
    [CHAR_SOUND_ATTACKED] = 'p_sev100_voice_e9.ogg',
	[CHAR_SOUND_EEUH] = 'p_sev100_voice_e143.ogg',
	[CHAR_SOUND_LETS_A_GO] = 'p_sev100_voice_e133.ogg',
    [CHAR_SOUND_DROWNING] = 'p_sev100_chatvoice_e13.ogg',
    [CHAR_SOUND_DYING] = 'p_sev100_voice_e22.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'p_sev100_voice_e54.ogg',
    [CHAR_SOUND_HAHA] = 'p_sev100_voice_e144.ogg',
    [CHAR_SOUND_HAHA_2] = 'p_sev100_voice_e134.ogg',
	[CHAR_SOUND_DOH] = 'p_sev100_voice_e5.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'p_sev100_chatvoice_e60.ogg',
    [CHAR_SOUND_HOOHOO] = 'p_sev100_voice_e144.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'p_sev100_chatvoice_e11.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'p_sev100_chatvoice_e14.ogg',
    [CHAR_SOUND_ON_FIRE] = 'p_sev100_voice_e1.ogg',
    [CHAR_SOUND_OOOF] = 'p_sev100_voice_e1.ogg',
    [CHAR_SOUND_OOOF2] = 'p_sev100_voice_e12.ogg',
	[CHAR_SOUND_HRMM] = 'p_sev100_voice_e145.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'p_sev100_voice_e140.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'p_sev100_voice_e141.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'p_sev100_voice_e57.ogg',
	[CHAR_SOUND_UH] = 'p_sev100_voice_e33.ogg',
    [CHAR_SOUND_UH2] = 'p_sev100_voice_e31.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'p_sev100_voice_e109.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'p_sev100_chatvoice_e19.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'p_sev100_voice_e15.ogg',
    [CHAR_SOUND_WAH2] = 'p_sev100_voice_e149.ogg',
    [CHAR_SOUND_WHOA] = 'p_sev100_voice_e7.ogg',
    [CHAR_SOUND_YAHOO] = 'p_sev100_voice_e41.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'p_sev100_voice_e146.ogg', 'p_sev100_voice_e147.ogg', 'p_sev100_voice_e148.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'p_sev100_voice_e140.ogg', 'p_sev100_voice_e141.ogg', 'p_sev100_voice_e57.ogg'},
}

local PALETTE_CLOUD = {
    [PANTS]  = "331000",
    [SHIRT]  = "604A76",
    [GLOVES] = "333333",
    [SHOES]  = "4F3C0D",
    [HAIR]   = "DFA32E",
    [SKIN]   = "F7A986",
    [CAP]    = "5B1B00",
}

if _G.charSelectExists then
    _G.charSelect.character_add("Cloud Strife", {"All right everyone, let's mosey."}, "eldritchmeat / Square Enix", {r = 77, g = 156, b = 137}, E_MODEL_CLOUD_MODEL, CT_MARIO, get_texture_info("cloud"))

    _G.charSelect.character_add_voice(E_MODEL_CLOUD_MODEL, VOICETABLE_CLOUD)
    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_CLOUD then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_CLOUD then return _G.charSelect.voice.snore(m) end
    end)
else
    djui_popup_create("\\#a32317\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end


local E_MODEL_TIFA_MODEL = smlua_model_util_get_id("tifa_geo")

local TEXT_MOD_NAME = "Tifa Lockheart"

local VOICETABLE_TIFA = {
    [CHAR_SOUND_ATTACKED] = 'p_dlc110_voice_e12.ogg',
	[CHAR_SOUND_EEUH] = 'p_dlc110_voice_e154.ogg',
	[CHAR_SOUND_LETS_A_GO] = 'p_dlc110_chatvoice_e64.ogg',
    [CHAR_SOUND_DROWNING] = 'p_dlc110_voice_e23.ogg',
    [CHAR_SOUND_DYING] = 'p_dlc110_voice_e24.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'p_dlc110_voice_e42.ogg',
    [CHAR_SOUND_HAHA] = 'p_dlc110_voice_e38.ogg',
    [CHAR_SOUND_HAHA_2] = 'perfect.ogg',
	[CHAR_SOUND_DOH] = 'p_dlc110_voice_e6.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'p_dlc110_chatvoice_e7.ogg',
    [CHAR_SOUND_HOOHOO] = 'p_dlc110_voice_e39.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'p_dlc110_chatvoice_e60.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'p_dlc110_voice_e151.ogg',
    [CHAR_SOUND_ON_FIRE] = 'p_dlc110_voice_e11.ogg',
    [CHAR_SOUND_OOOF] = 'p_dlc110_voice_e3.ogg',
    [CHAR_SOUND_OOOF2] = 'p_dlc110_voice_e36.ogg',
	[CHAR_SOUND_HRMM] = 'p_dlc110_voice_e21.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'p_dlc110_voice_e50.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'p_dlc110_voice_e49.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'p_dlc110_voice_e47.ogg',
	[CHAR_SOUND_UH] = 'p_dlc110_voice_e45.ogg',
    [CHAR_SOUND_UH2] = 'p_dlc110_voice_e4.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'p_dlc110_voice_e102.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'p_dlc110_voice_e141.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'p_dlc110_voice_e14.ogg',
    [CHAR_SOUND_WAH2] = 'p_dlc110_voice_e16.ogg',
    [CHAR_SOUND_WHOA] = 'p_dlc110_voice_e155.ogg',
    [CHAR_SOUND_YAHOO] = 'p_dlc110_voice_e46.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'p_dlc110_voice_e29.ogg', 'p_dlc110_voice_e30.ogg', 'p_dlc110_voice_e31.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'p_dlc110_voice_e47.ogg', 'p_dlc110_voice_e49.ogg', 'p_dlc110_voice_e50.ogg'},
}

if _G.charSelectExists then
    _G.charSelect.character_add("Tifa Lockheart", {"I'll smash them."}, "eldritchmeat / Square Enix", {r = 190, g = 64, b = 53}, E_MODEL_TIFA_MODEL, CT_MARIO, get_texture_info("tifa"))

    _G.charSelect.character_add_voice(E_MODEL_TIFA_MODEL, VOICETABLE_TIFA)
    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_TIFA then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_TIFA then return _G.charSelect.voice.snore(m) end
    end)
else
    djui_popup_create("\\#a32317\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end


local E_MODEL_BARRET_MODEL = smlua_model_util_get_id("barret_geo")

local TEXT_MOD_NAME = "Barret Wallace"

local VOICETABLE_BARRET = {
    [CHAR_SOUND_ATTACKED] = 'barret_hurt.ogg',
	[CHAR_SOUND_EEUH] = 'barret_hugh.ogg',
	[CHAR_SOUND_LETS_A_GO] = 'barret_realintro.ogg',
    [CHAR_SOUND_DROWNING] = 'barret_drown.ogg',
    [CHAR_SOUND_DYING] = 'barret_death.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'barret_groundpound.ogg',
    [CHAR_SOUND_HAHA] = 'barret_grunt.ogg',
    [CHAR_SOUND_HAHA_2] = 'barret_haha.ogg',
	[CHAR_SOUND_DOH] = 'barret_doh.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'barret_letsgo.ogg',
    [CHAR_SOUND_HOOHOO] = 'barret_hoohoo.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'barret_attention.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'barret_mhm.ogg',
    [CHAR_SOUND_ON_FIRE] = 'barret_fire.ogg',
    [CHAR_SOUND_OOOF] = 'barret_oof.ogg',
    [CHAR_SOUND_OOOF2] = 'barret_shit.ogg',
	[CHAR_SOUND_HRMM] = 'barret_hrm.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'barret_hah.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'barret_hoo.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'barret_wah.ogg',
	[CHAR_SOUND_UH] = 'barret_uh.ogg',
    [CHAR_SOUND_UH2] = 'barret_uh2.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'barret_bowser.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'dumbass.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'barret_woaw.ogg',
    [CHAR_SOUND_WAH2] = 'barret_toss.ogg',
    [CHAR_SOUND_WHOA] = 'barret_whoa.ogg',
    [CHAR_SOUND_YAHOO] = 'barret_yahoo.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'barret_jump1.ogg', 'barret_jump2.ogg', 'barret_jump3.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'barret_hah.ogg', 'barret_hoo.ogg', 'barret_wah.ogg'},
}

if _G.charSelectExists then
    _G.charSelect.character_add("Barret Wallace", {"C'mon newcomer. Follow me."}, "eldritchmeat / Square Enix", {r = 101, g = 101, b = 38}, E_MODEL_BARRET_MODEL, CT_MARIO, get_texture_info("barret"))

    _G.charSelect.character_add_voice(E_MODEL_BARRET_MODEL, VOICETABLE_BARRET)
    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_BARRET then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_BARRET then return _G.charSelect.voice.snore(m) end
    end)
else
    djui_popup_create("\\#a32317\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end


local E_MODEL_AERITH_MODEL = smlua_model_util_get_id("aerith_geo")

local TEXT_MOD_NAME = "Aerith Gainsborough"

local VOICETABLE_AERITH = {
    [CHAR_SOUND_ATTACKED] = 'aerith_ouch.ogg',
	[CHAR_SOUND_EEUH] = 'aerith_grunt.ogg',
	[CHAR_SOUND_LETS_A_GO] = 'aerith_letsgo.ogg',
    [CHAR_SOUND_DROWNING] = 'aerith_drown.ogg',
    [CHAR_SOUND_DYING] = 'aerith_death.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'aerith_groundpound.ogg',
    [CHAR_SOUND_HAHA] = 'aerith_haha.ogg',
    [CHAR_SOUND_HAHA_2] = 'aerith_ok.ogg',
	[CHAR_SOUND_DOH] = 'aerith_hey.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'aerith_finish.ogg',
    [CHAR_SOUND_HOOHOO] = 'aerith_yah.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'aerith_mama.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'aerith_kay.ogg',
    [CHAR_SOUND_ON_FIRE] = 'aerith_fire.ogg',
    [CHAR_SOUND_OOOF] = 'aerith_oof.ogg',
    [CHAR_SOUND_OOOF2] = 'aerith_oof2.ogg',
	[CHAR_SOUND_HRMM] = 'aerith_lift.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'aerith_punch3.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'aerith_punch2.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'aerith_punch1.ogg',
	[CHAR_SOUND_UH] = 'aerith_uh.ogg',
    [CHAR_SOUND_UH2] = 'aerith_uh2.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'aerith_bowser.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'aerith_sorry.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'aerith_scream.ogg',
    [CHAR_SOUND_WAH2] = 'aerith_throw.ogg',
    [CHAR_SOUND_WHOA] = 'aerith_whuh.ogg',
    [CHAR_SOUND_YAHOO] = 'aerith_yahoo.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'aerith_jump1.ogg', 'aerith_jump2.ogg', 'aerith_jump3.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'aerith_punch1.ogg', 'aerith_punch2.ogg', 'aerith_punch3.ogg'},
}

if _G.charSelectExists then
    _G.charSelect.character_add("Aerith Gainsborough", {"Don't fight here! You'll ruin the flowers!"}, "eldritchmeat / Square Enix", {r = 193, g = 137, b = 137}, E_MODEL_AERITH_MODEL, CT_MARIO, get_texture_info("aerith"))

    _G.charSelect.character_add_voice(E_MODEL_AERITH_MODEL, VOICETABLE_AERITH)
    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_AERITH then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_AERITH then return _G.charSelect.voice.snore(m) end
    end)
else
    djui_popup_create("\\#a32317\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end